#include <stdio.h>
#include "types.h"
#include "brain.h"

void main(argc, argv)
    int argc;
    char **argv;
{
    int i;
    FILE *gen;
    param brain;

    if(argc!=2)
    {
	printf("Usage: generate brain.brn\n");
	exit(1);
    }

    gen = fopen("../xfortress/genbrain.c", "w");
    if(!gen)
    {
	printf("You must be in 'evolve' to use this\n");
	exit(1);
    }
    LoadBrain(argv[1], brain);

    fprintf(gen, "#include \"types.h\"\n#include \"genbrain.h\"\n\nvoid GenBrain(brain)\n    param brain;\n{\n");
    fprintf(gen, " /*\n  * This brain has been generated from '%s'\n  */\n\n", argv[1]);
    for(i=0;i<42;i++)
    {
	fprintf(gen,"    brain[%d].my_score_rate = %f;\n", i, brain[i].my_score_rate);
	fprintf(gen,"    brain[%d].opp_score_rate = %f;\n", i, brain[i].opp_score_rate);
	fprintf(gen,"    brain[%d].protect_pos_rate = %f;\n", i, brain[i].protect_pos_rate);
	fprintf(gen,"    brain[%d].attack_pos_rate = %f;\n", i, brain[i].attack_pos_rate);
	fprintf(gen,"    brain[%d].board_score_rate = %f;\n", i, brain[i].board_score_rate);
	fprintf(gen,"    brain[%d].play_opp_flag = %f;\n", i, brain[i].play_opp_flag);
	fprintf(gen,"    brain[%d].defensive_rate = %f;\n", i, brain[i].defensive_rate);
	fprintf(gen,"    brain[%d].offensive_rate = %f;\n", i, brain[i].offensive_rate);
	fprintf(gen,"    brain[%d].position_rate = %f;\n", i, brain[i].position_rate);
    }
    fprintf(gen,"}\n");
    fclose(gen);
    printf("Generation OK, now (re)compile xfortress\n");
}
