#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include "defs.h"
#include "stypes.h"
#include "scell.h"
#include "list.h"
#include "socket.h"

void FreeArenaCell(type, cell)
    int type;
    void *cell;
{
    if(!cell)
	return;
    switch(type) {
    case CELL_ARENA:
	break;
    default:
	printf("**** PANIC! **** UNKNOWN CELL TYPE IN FreeCell\n");
	break;
    }
    free(cell);
}

arena_cell *CreateArenaCell(x, y)
    int x,y;
{
    arena_cell *ac;
    
    ac = (arena_cell *)malloc(sizeof(arena_cell));
    ac->x = x;
    ac->y = y;

    return ac;
}

void PurgeCell(TheList, x, y)
    list **TheList;
    int  x, y;
{
    list       *tmp_link, *next_link;
    int        is_first;
    arena_cell *curr_cell;

    is_first = TRUE;
    for(tmp_link = *TheList; tmp_link ;) {
	curr_cell = (arena_cell *)tmp_link->cell;
	if((curr_cell->x == x) && (curr_cell->y == y)) {
	    next_link = tmp_link->next;
	    SwallowLink(tmp_link);
            FreeArenaCell(CELL_ARENA, curr_cell);
            if(is_first && !next_link)
                *TheList = NULL;
            else
                if(is_first)
                    *TheList = next_link;
            free(tmp_link);
            tmp_link = next_link;
        } else {
            tmp_link = tmp_link->next;
            is_first = FALSE;
        }
    }
}

