#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <malloc.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifndef SUNOS
#include <sys/resource.h>
#endif /* !SUNOS */
#include <sys/signal.h>
#include <sys/time.h>
#include <netinet/in.h>
#include "defs.h"
#include "types.h"
#include "strategie.h"
#include "tools.h"
#include "socket.h"
#include "etypes.h"

#define PMIN(a,b) ((a<b)?a:b)
#ifndef MAX_TURN
#  define MAX_TURN 18
#endif
#ifndef MAX_DEPTH
#  define MAX_DEPTH 6
#endif
#ifndef DEPTH
#  define DEPTH 4
#endif

void play_game(param, param, int *, int *, char *);

void play_game(br1, br2, score1, score2, log)
    param br1, br2;
    int *score1, *score2;
    char *log;
{
    int pl, i, c;
    board pb, cb;
    pred pwhere;
    char *l;

    l = log;
    for(i=0; i<36; i++) {
	pb[i] = cb[i] = 0;
    }
    pl = 1;
    for(i=0;i<MAX_TURN;i++) {
	c = AlphaBeta(pb, cb, pl, DEPTH, i*2, pwhere, br1);
	*l++ = pwhere[DEPTH]+65;
	if(pl>0)
	    PlayWhite(pb, cb, pwhere[DEPTH]);
	else
	    PlayBlack(pb, cb, pwhere[DEPTH]);
	pl = -pl;
	c = AlphaBeta(pb, cb, pl, DEPTH, i*2+1, pwhere, br2);
	*l++ = pwhere[DEPTH]+65;
	if(pl>0)
	    PlayWhite(pb, cb, pwhere[DEPTH]);
	else
	    PlayBlack(pb, cb, pwhere[DEPTH]);
	pl = -pl;
    }
    for(i=2*MAX_TURN;i<42;i++) {
	c = EndAlphaBeta(pb, cb, pl, PMIN(4, 42-i), i, pwhere);
	*l++ = pwhere[PMIN(4, 42-i)]+65;
	if(pl>0)
	    PlayWhite(pb, cb, pwhere[PMIN(4, 42-i)]);
	else
	    PlayBlack(pb, cb, pwhere[PMIN(4, 42-i)]);
	pl = -pl;
    }
    *l = 0;
    Score(pb, cb, score1, score2);
}
    

void main(argc, argv)
    int argc;
    char **argv;
{
    int  port = 8007;
    int max_fd;
    int nbcalc = 0;
    int score1, score2;
    int currbrain, currcell;
    char *server;
    char *parse;
    char tobeparsed[SOCKET_BUFFER_SIZE];
    char dump[128];
    char log[64];
    slave me;
    struct timeval timeout;
    time_t last_comm, connect_time;
    fd_set rd;
#ifndef _HAS_USLEEP
    int dfd = 0;
#endif /* _HAS_USLEEP */
#ifndef SUNOS
    struct rlimit rlp;
#endif /* !SUNOS */

    param br1, br2;

    if(argc == 1) {
	printf("Usage:\n  slave server [host]\n");
	exit(1);
    }
    me.buffer = NULL;
    me.status = 0;
    me.buffer = (char *)calloc(SOCKET_BUFFER_SIZE, sizeof(char));
	/* just in case, for broken compilers/libraries */
    server = argv[1];
    if(argc == 3) 
	port = atoi(argv[2]);
    
#ifdef SUNOS
    max_fd = getdtablesize();
#else
    getrlimit(RLIMIT_NOFILE, &rlp);
    max_fd = (int) rlp.rlim_cur;
#endif /* SUNOS */

    while(1) {
	while(!me.status) {
	    me.socket = connection(server, port);
	    if(me.socket == -1) {
		connect_time = time((time_t *)NULL);
		while(difftime(time((time_t *)NULL), connect_time)< 30) {
#ifndef _HAS_USLEEP
		    timeout.tv_sec=1;
		    timeout.tv_usec=0;		
		    select(dfd, NULL, NULL, NULL, &timeout);
#else
		    usleep(1000000);
#endif /* _HAS_USLEEP */
		}
	    } else {
		printf("Connected!\n");
		me.status = 1;
	    }
	}
	me.curr = me.buffer;
	currbrain = 0;
	currcell = 0;

	last_comm = time((time_t *)NULL);
	while(me.status) {

	    FD_ZERO(&rd);
	    FD_SET(me.socket, &rd);
	    timeout.tv_sec=1;
	    timeout.tv_usec=0;
	    
	    select(max_fd, &rd, NULL, NULL, &timeout);
	    
	    if(FD_ISSET(me.socket, &rd)) {
		me.status = read_socket(me.socket, me.buffer, &me.curr,
					tobeparsed);
		parse = tobeparsed;
		if(me.status) {
		    while(me.status && parse) {
			if(currbrain == 0)
			    sscanf(parse, "%f %f %f %f %f %f %f %f %f",
				   &br1[currcell].my_score_rate,
				   &br1[currcell].opp_score_rate,
				   &br1[currcell].protect_pos_rate,
				   &br1[currcell].attack_pos_rate,
				   &br1[currcell].board_score_rate,
				   &br1[currcell].play_opp_flag,
				   &br1[currcell].defensive_rate,
				   &br1[currcell].offensive_rate,
				   &br1[currcell].position_rate);
			else
			    sscanf(parse, "%f %f %f %f %f %f %f %f %f",
				   &br2[currcell].my_score_rate,
				   &br2[currcell].opp_score_rate,
				   &br2[currcell].protect_pos_rate,
				   &br2[currcell].attack_pos_rate,
				   &br2[currcell].board_score_rate,
				   &br2[currcell].play_opp_flag,
				   &br2[currcell].defensive_rate,
				   &br2[currcell].offensive_rate,
				   &br2[currcell].position_rate);
			currcell++;
			if(currcell == 42) {
			    if(currbrain == 0) {
				currbrain++;
				currcell = 0;
			    } else {
				/* calculate */
				nbcalc++;
				printf("Computing %d ", nbcalc);
				play_game(br1, br2, &score1, &score2, log);
				sprintf(dump, "%s %d %d END\n", log, score1, score2);
				me.status = send_socket(me.socket, dump);
				currbrain = 0;
				currcell = 0;
				printf("%s", dump);
				last_comm = time((time_t *)NULL);
			    }
			}
			parse = strchr(parse, '\n');
			if(parse)
			    parse++;
		    }
		}
	    }
	    if(difftime(time((time_t *)NULL), last_comm)>300) {
	        me.status = 0;
		shutdown(me.socket, 2);
		close(me.socket);
	    } 
	}
    }
}
