#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <unistd.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#ifdef NODELAY
#include <netinet/tcp.h>
#endif /* NODELAY */
#include <sys/utsname.h>
#include "defs.h"
#include "socket.h"

int connection(host, port)
    char *host;
    int port;
{
    int done;
    int sock=0;
    struct hostent *hptr;
    struct sockaddr_in adsock = {AF_INET};
#ifdef NODELAY
    int val = 1;
#endif /* NODELAY */
  
    printf("Trying to connect to %s on port %d\n", host, port);
    done=1;
    if((hptr=gethostbyname(host))==NULL) {
	done=0;
	perror("Unable to get host");
    } else {
#ifdef SUNOS
	bcopy((char *)hptr->h_addr, (char *)&adsock.sin_addr, hptr->h_length);
#else
	memcpy((void *)&adsock.sin_addr, (void *)hptr->h_addr,
	       (unsigned int)hptr->h_length);
#endif /* SUNOS */
	adsock.sin_family=hptr->h_addrtype;
	adsock.sin_port=htons(port);
	if((sock=socket(AF_INET,SOCK_STREAM,0))<0) {
	    done=0;
	    perror("Unable to create socket");
	} else {
	    setsockopt(sock,SOL_SOCKET,SO_LINGER,0,0);
	    setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,0,0);
#ifdef NODELAY
	    setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (void *)val, sizeof(val));
#endif /* NODELAY */
	    if(connect(sock,(struct sockaddr *)&adsock,sizeof(adsock))<0) {
		done=0;
		close(sock);
		perror("Unable to connect");
	    }
	}
    }
    return((done) ? sock : -1);
}

int server(port)
    int port;
{
    int done;
    int sock=0;
    struct hostent *hptr;
    struct sockaddr_in adsock = {AF_INET};
    struct utsname name;
  
    printf("Trying to bind socket on port %d\n",port);
    done=1;

    uname(&name);

    if((hptr=gethostbyname(name.nodename))==NULL){
	done=0;
	perror("Unable to get host");
    } else {
#ifdef SUNOS
	bcopy((char *)hptr->h_addr, (char *)&adsock.sin_addr, hptr->h_length);
#else
	memcpy((void *)&adsock.sin_addr, (void *)hptr->h_addr,
	       (unsigned int)hptr->h_length);
#endif /* SUNOS */
	adsock.sin_family=hptr->h_addrtype;
	adsock.sin_port=htons(port);
	if((sock=socket(AF_INET,SOCK_STREAM,0))<0) {
	    done=0;
	    perror("Unable to create socket for listening");
	} else {
	    if(bind(sock,(struct sockaddr *)&adsock,sizeof(adsock))<0){
		done=0;
		close(sock);
		perror("Unable to bind");
	    }
	}
    }
    return((done) ? sock : -1);
}

int send_socket(sock, msg)
    int sock;
    char *msg;
{
    return write(sock, msg, strlen(msg)) != -1;
}

int read_socket(sock, buffer, curr, result)
    int sock;
    char *buffer, **curr, *result;
{  
    register char *npos,*cpy,*cpyresult;
    int nb_read,s_size;
    register int i;
     
    errno=0;
    nb_read=read(sock,*curr,(SOCKET_BUFFER_SIZE-1+buffer-*curr));
     
    if(!nb_read)
	return 0;
    else{
	*(*curr+nb_read)=0;
	npos=buffer;
	cpy =buffer;
	while(*cpy)
	    if(*cpy++ == '\n')
		npos = cpy;
	s_size = (npos-buffer-1);
	cpy = buffer;
	cpyresult = result;
	for(i=0;i<s_size;i++)
	    *cpyresult++ = *cpy++;
	*cpyresult=0;
	 
	cpy = buffer;
	while(*npos)
	    *cpy++ = *npos++;
	*curr=cpy;
	return 1;
    }
}
