#include <stdio.h>
#include "types.h"
#include "brain.h"

void CopyBrainCell(orig_b, copy_b)
    param_cell orig_b, *copy_b;
{
    copy_b->my_score_rate    = orig_b.my_score_rate;
    copy_b->opp_score_rate   = orig_b.opp_score_rate;
    copy_b->protect_pos_rate = orig_b.protect_pos_rate;
    copy_b->attack_pos_rate  = orig_b.attack_pos_rate;
    copy_b->board_score_rate = orig_b.board_score_rate;
    copy_b->play_opp_flag    = orig_b.play_opp_flag;
    copy_b->defensive_rate   = orig_b.defensive_rate;
    copy_b->offensive_rate   = orig_b.offensive_rate;
    copy_b->position_rate    = orig_b.position_rate;
}

void CopyBrain(orig_b, copy_b)
    param orig_b, copy_b;
{
    int i;

    for(i=0;i<42;i++)
	CopyBrainCell(orig_b[i], &copy_b[i]);
}

void LoadBrain(filename, brain)
    char *filename;
    param brain;
{
    FILE *fl;
    int i;

    fl = fopen(filename, "r");

    if(!fl)
    {
	printf("Brain %s does not exist...\n", filename);
	exit(1);
    }
    for(i=0;i<42;i++)
    {
#ifdef FLOAT_PARAM
	fscanf(fl, "%f", &(brain[i].my_score_rate   ));
	fscanf(fl, "%f", &(brain[i].opp_score_rate  ));
	fscanf(fl, "%f", &(brain[i].protect_pos_rate));
	fscanf(fl, "%f", &(brain[i].attack_pos_rate ));
	fscanf(fl, "%f", &(brain[i].board_score_rate));
	fscanf(fl, "%f", &(brain[i].play_opp_flag   ));
	fscanf(fl, "%f", &(brain[i].defensive_rate  ));
	fscanf(fl, "%f", &(brain[i].offensive_rate  ));
	fscanf(fl, "%f", &(brain[i].position_rate   ));
#else
	fscanf(fl, "%d", &(brain[i].my_score_rate   ));
	fscanf(fl, "%d", &(brain[i].opp_score_rate  ));
	fscanf(fl, "%d", &(brain[i].protect_pos_rate));
	fscanf(fl, "%d", &(brain[i].attack_pos_rate ));
	fscanf(fl, "%d", &(brain[i].board_score_rate));
	fscanf(fl, "%d", &(brain[i].play_opp_flag   ));
	fscanf(fl, "%d", &(brain[i].defensive_rate  ));
	fscanf(fl, "%d", &(brain[i].offensive_rate  ));
	fscanf(fl, "%d", &(brain[i].position_rate   ));
#endif
    }
    fclose(fl);
}

void SaveBrain(filename, brain)
    char *filename;
    param brain;
{
    FILE *fl;
    int i;
    
    fl = fopen(filename, "w");

    if(!fl)
    {
	printf("Brain %s cannot be created...\n", filename);
	exit(1);
    }
    for(i=0;i<42;i++)
    {
#ifdef FLOAT_PARAM
	fprintf(fl, "%f " , brain[i].my_score_rate   );
	fprintf(fl, "%f " , brain[i].opp_score_rate  );
	fprintf(fl, "%f " , brain[i].protect_pos_rate);
	fprintf(fl, "%f " , brain[i].attack_pos_rate );
	fprintf(fl, "%f " , brain[i].board_score_rate);
	fprintf(fl, "%f " , brain[i].play_opp_flag   );
	fprintf(fl, "%f " , brain[i].defensive_rate  );
	fprintf(fl, "%f " , brain[i].offensive_rate  );
	fprintf(fl, "%f\n", brain[i].position_rate   );
#else
	fprintf(fl, "%d " , brain[i].my_score_rate   );
	fprintf(fl, "%d " , brain[i].opp_score_rate  );
	fprintf(fl, "%d " , brain[i].protect_pos_rate);
	fprintf(fl, "%d " , brain[i].attack_pos_rate );
	fprintf(fl, "%d " , brain[i].board_score_rate);
	fprintf(fl, "%d " , brain[i].play_opp_flag   );
	fprintf(fl, "%d " , brain[i].defensive_rate  );
	fprintf(fl, "%d " , brain[i].offensive_rate  );
	fprintf(fl, "%d\n", brain[i].position_rate   );
#endif
    }
    fclose(fl);
}
