/*
 * Compute the influences from the 'play' board game
 * Computation of attacks
 * Real score
 * some heavily used functions has been optimized
 */

#include "types.h"
#include "tools.h"

#ifdef NOMEMCPY
void Copy(orig_b, copy_b)
    void *orig_b, *copy_b;
{
#define cpy(x) c_b[x] = o_b[x]
#ifdef NO_DEFERENCING
    short *c_b, *o_b;
#else
    int *c_b, *o_b;
#endif /* NO_DEFERENCING */

    c_b = copy_b;
    o_b = orig_b;

    cpy(0); cpy(1); cpy(2); cpy(3); cpy(4); cpy(5);
    cpy(6); cpy(7); cpy(8); cpy(9); cpy(10);cpy(11);
    cpy(12);cpy(13);cpy(14);cpy(15);cpy(16);cpy(17);
#ifdef NO_DEFERENCING
    cpy(18);cpy(19);cpy(20);cpy(21);cpy(22);cpy(23);
    cpy(24);cpy(25);cpy(26);cpy(27);cpy(28);cpy(29);
    cpy(30);cpy(31);cpy(32);cpy(33);cpy(34);cpy(35);
#endif /* NO_DEFERENCING */

    /*
     * It can be good to rewrite this in assembly code.
     */
}
#endif /* NOMEMCPY */

void Calc(play_b, calc_b)
    board play_b, calc_b;
{
    /*
     * Fully unrolled function :)
     */
     
    calc_b[0]  =                           play_b[0]  + play_b[1]  + play_b[6];
    calc_b[1]  =              play_b[0]  + play_b[1]  + play_b[2]  + play_b[7];
    calc_b[2]  =              play_b[1]  + play_b[2]  + play_b[3]  + play_b[8];
    calc_b[3]  =              play_b[2]  + play_b[3]  + play_b[4]  + play_b[9];
    calc_b[4]  =              play_b[3]  + play_b[4]  + play_b[5]  + play_b[10];
    calc_b[5]  =              play_b[4]  + play_b[5]               + play_b[11];

    calc_b[6]  = play_b[0]  +              play_b[6]  + play_b[7]  + play_b[12];
    calc_b[7]  = play_b[1]  + play_b[6]  + play_b[7]  + play_b[8]  + play_b[13];
    calc_b[8]  = play_b[2]  + play_b[7]  + play_b[8]  + play_b[9]  + play_b[14];
    calc_b[9]  = play_b[3]  + play_b[8]  + play_b[9]  + play_b[10] + play_b[15];
    calc_b[10] = play_b[4]  + play_b[9]  + play_b[10] + play_b[11] + play_b[16];
    calc_b[11] = play_b[5]  + play_b[10] + play_b[11] +              play_b[17];

    calc_b[12] = play_b[6]  +              play_b[12] + play_b[13] + play_b[18];
    calc_b[13] = play_b[7]  + play_b[12] + play_b[13] + play_b[14] + play_b[19];
    calc_b[14] = play_b[8]  + play_b[13] + play_b[14] + play_b[15] + play_b[20];
    calc_b[15] = play_b[9]  + play_b[14] + play_b[15] + play_b[16] + play_b[21];
    calc_b[16] = play_b[10] + play_b[15] + play_b[16] + play_b[17] + play_b[22];
    calc_b[17] = play_b[11] + play_b[16] + play_b[17] +              play_b[23];

    calc_b[18] = play_b[12] +              play_b[18] + play_b[19] + play_b[24];
    calc_b[19] = play_b[13] + play_b[18] + play_b[19] + play_b[20] + play_b[25];
    calc_b[20] = play_b[14] + play_b[19] + play_b[20] + play_b[21] + play_b[26];
    calc_b[21] = play_b[15] + play_b[20] + play_b[21] + play_b[22] + play_b[27];
    calc_b[22] = play_b[16] + play_b[21] + play_b[22] + play_b[23] + play_b[28];
    calc_b[23] = play_b[17] + play_b[22] + play_b[23] +              play_b[29];

    calc_b[24] = play_b[18] +              play_b[24] + play_b[25] + play_b[30];
    calc_b[25] = play_b[19] + play_b[24] + play_b[25] + play_b[26] + play_b[31];
    calc_b[26] = play_b[20] + play_b[25] + play_b[26] + play_b[27] + play_b[32];
    calc_b[27] = play_b[21] + play_b[26] + play_b[27] + play_b[28] + play_b[33];
    calc_b[28] = play_b[22] + play_b[27] + play_b[28] + play_b[29] + play_b[34];
    calc_b[29] = play_b[23] + play_b[28] + play_b[29] +              play_b[35];

    calc_b[30] = play_b[24] +              play_b[30] + play_b[31];
    calc_b[31] = play_b[25] + play_b[30] + play_b[31] + play_b[32];
    calc_b[32] = play_b[26] + play_b[31] + play_b[32] + play_b[33];
    calc_b[33] = play_b[27] + play_b[32] + play_b[33] + play_b[34];
    calc_b[34] = play_b[28] + play_b[33] + play_b[34] + play_b[35];
    calc_b[35] = play_b[29] + play_b[34] + play_b[35];
}

int Prise(play_b, calc_b, where)
    board play_b, calc_b;
    int where;
{
    int pris;

    pris = 0;

    if((play_b[where]<0 && calc_b[where]>0) || (play_b[where]>0 && calc_b[where]<0))
    {
	pris++;
	play_b[where]=0;
    }

    if(where)
    {
	if((play_b[where-1]<0 && calc_b[where-1]>0) || (play_b[where-1]>0 && calc_b[where-1]<0))
	{
	    pris++;
	    play_b[where-1]=0;
	}
    }

    if(where>5)
    {
	if((play_b[where-6]<0 && calc_b[where-6]>0) || (play_b[where-6]>0 && calc_b[where-6]<0))
	{
	    pris++;
	    play_b[where-6]=0;
	}
    }

    if(where!=35)
    {
	if((play_b[where+1]<0 && calc_b[where+1]>0) || (play_b[where+1]>0 && calc_b[where+1]<0))
	{
	    pris++;
	    play_b[where+1]=0;
	}
    }

    if(where<30)
    {
	if((play_b[where+6]<0 && calc_b[where+6]>0) || (play_b[where+6]>0 && calc_b[where+6]<0))
	{
	    pris++;
	    play_b[where+6]=0;
	}
    }
    
    if(pris)
    {
	/*
	 * Argh!!! Bad case! we must recompute everything and do expansions
	 * expansion causes 25 computations instead of 36 if it stops after
	 * the first propagation level (ie 99.9999% ;) ).
	 * It can be optimized better to avoid computing the diagonals two times.
	 * but with more code (it is better to optimize the algorithms!)
	 */

	Calc(play_b, calc_b);
	if(where)
	    Prise(play_b, calc_b, where-1);
	if(where>5)
	    Prise(play_b, calc_b, where-6);
	if(where!=35)
	    Prise(play_b, calc_b, where+1);
	if(where<30)
	    Prise(play_b, calc_b, where+6);
    }
    return pris;
}
    
void Score(play_b, calc_b, w_score, b_score)
    board play_b, calc_b;
    int *w_score, *b_score;
{
    int i;
    int w_s, b_s;
    
    w_s = 0;
    b_s = 0;
    
    /*
     * calc_b and play_b are added to have at the same time squares
     * under influence and castle under 0 influence.
     */

    for(i=0; i<36; i++)
    {
	if(play_b[i]+calc_b[i] < 0)
	    b_s++;
	else
	    if(play_b[i]+calc_b[i])
		w_s++;
    }
    *w_score = w_s;
    *b_score = b_s;
}

int EndScore(play_b, calc_b, player)
    board play_b, calc_b;
    int player;
{
    int i;
    int score;
    
    score = 0;
     
    for(i=0; i<36; i++)
    {
	if(play_b[i]<0 || calc_b[i]<0)
	    score--;
	else
	    if(play_b[i]>0 || calc_b[i]>0)
		score++;
    }
    return ((player>0) ? score : -score);
} 

int IsValidMove(play_b, player, where)
    board play_b;
    int player, where;
{
    if(player>0)
    {
	if(play_b[where]<0 || play_b[where] == 3)
	    return 0;
	else 
	    return 1;
    }
    else
    {
	if(play_b[where]>0 || play_b[where] == -3)
	    return 0;
	else 
	    return 1;
    }
}

int PlayBlack(play_b, calc_b, where)
    board play_b, calc_b;
    int where;
{
    play_b[where] -=1;
    calc_b[where] -=1;

    if(where>5)
	calc_b[where-6] -=1;
    if(where<30)
	calc_b[where+6] -=1;
    if(where && where != 6 && where != 12 && where != 18 && where != 24 && where !=30)
	calc_b[where-1] -=1;
    if(where != 5 && where != 11 && where != 17 && where != 23 && where != 29 && where != 35)
	calc_b[where+1] -=1;

    return (Prise(play_b, calc_b, where));
}

int PlayWhite(play_b, calc_b, where)
    board play_b, calc_b;
    int where;
{
    play_b[where] +=1;
    calc_b[where] +=1;
    
    if(where>5)
	calc_b[where-6] +=1;
    if(where<30)
	calc_b[where+6] +=1;
    if(where && where != 6 && where != 12 && where != 18 && where != 24 && where !=30)
	calc_b[where-1] +=1;
    if(where != 5 && where != 11 && where != 17 && where != 23 && where != 29 && where != 35)
	calc_b[where+1] +=1;
    
    return (Prise(play_b, calc_b, where));
}

void UnPlayWhite(play_b, calc_b, where)
    board play_b, calc_b;
    int where;
{
    play_b[where] -=1;
    calc_b[where] -=1;

    if(where>5)
	calc_b[where-6] -=1;
    if(where<30)
	calc_b[where+6] -=1;
    if(where && where != 6 && where != 12 && where != 18 && where != 24 && where !=30)
	calc_b[where-1] -=1;
    if(where != 5 && where != 11 && where != 17 && where != 23 && where != 29 && where != 35)
	calc_b[where+1] -=1;
}

void UnPlayBlack(play_b, calc_b, where)
    board play_b, calc_b;
    int where;
{
    play_b[where] +=1;
    calc_b[where] +=1;
    
    if(where>5)
	calc_b[where-6] +=1;
    if(where<30)
	calc_b[where+6] +=1;
    if(where && where != 6 && where != 12 && where != 18 && where != 24 && where !=30)
	calc_b[where-1] +=1;
    if(where != 5 && where != 11 && where != 17 && where != 23 && where != 29 && where != 35)
	calc_b[where+1] +=1;
    
}

void BubbleSort(where_list, where_result)
    int where_list[36], where_result[36];
{
    int ok, i, dump;
    
    ok = 1;
    
    while(ok)
    {
	ok = 0;
	for(i=0; i<35; i++)
	if(where_result[i]<where_result[i+1])
	{
	    ok=1;
	    dump = where_result[i];
	    where_result[i] = where_result[i+1];
	    where_result[i+1] = dump;
	    dump = where_list[i];
	    where_list[i] = where_list[i+1];
	    where_list[i+1] = dump;
	}
    }
}
