#include <stdio.h>
#include "xfortress.h"
#include "callback.h"
#include "types.h"
#include "strategie.h"
#include "tools.h"

#define MAX_COUPS 42
#define FAST_EAB_START 35
#define EAB_START 37
#ifndef DEPTH
#define DEPTH 4
#endif
#define PMIN(a,b) ((a<b)?a:b)

void affichage(play_val,calc_val,tableau,is_last)
    int play_val,calc_val;
    Widget         tableau;
    int is_last;
{
    Arg	       ar[10];

    if (play_val)
    {
	if (play_val<0)
	{ 
	    XtSetArg(ar[0],XtNbitmap,pixtab[is_last][1-play_val+3*warn_*(!calc_val)]);
	}
	else
	{ 
	    XtSetArg(ar[0],XtNbitmap,pixtab[is_last][8+play_val+3*warn_*(!calc_val)]);
	};
    }
    else
    {
	if (calc_val)
	{
	    if (calc_val>0)
	    { 
		XtSetArg(ar[0],XtNbitmap,pixtab[is_last][8]);
	    }
	    else
	    { 
		XtSetArg(ar[0],XtNbitmap,pixtab[is_last][1]);
	    };
	}
	else
	{ 
	    XtSetArg(ar[0],XtNbitmap,pixtab[is_last][0]);
	};
    };
    XtSetValues(tableau,ar,1);

}

void single(w,client_data,call_data)
    Widget w;
    XtPointer client_data,call_data;
{
    is_single=!(is_single);
    if (is_single) { 
	XtSetArg(ar[0],XtNlabel,"SINGLE"); 
    } else { 
	XtSetArg(ar[0],XtNlabel," TWO  "); 
    };
    XtSetValues(wsingle,ar,1);
}

void setwarn(w,client_data,call_data)
    Widget w;
    XtPointer client_data,call_data;
{
    int ii,jj;

    warn_=!(warn_);
    if (warn_) { 
	XtSetArg(ar[0],XtNlabel," WARN "); 
    } else { 
	XtSetArg(ar[0],XtNlabel,"NOWARN"); 
    };
    XtSetValues(wwarn,ar,1);
    for(ii=1;ii<=6;ii++)
	for(jj=1;jj<=6;jj++)
	    affichage(play_board[(ii-1)*6+(jj-1)],calc_board[(ii-1)*6+(jj-1)],tabl[ii][jj],0);

}

void quit(w,client_data,call_data)
    Widget w;
    XtPointer client_data,call_data;
{
    exit(0);
}

void compuplay(w,client_data,call_data)
    Widget w;
    XtPointer client_data,call_data;
{
    int ii,jj,ii_last,jj_last,dump;
    pred p_list;
    if (coups<MAX_COUPS)
    {
      
	if (coups<FAST_EAB_START)
	{ 
	    jj = AlphaBeta(play_board, calc_board, player, DEPTH, coups, p_list, brain);
	    if(player>0)
		PlayWhite(play_board, calc_board, p_list[DEPTH]);
	    else
		PlayBlack(play_board, calc_board, p_list[DEPTH]);
	    ii = p_list[DEPTH];
	}
	else 
	{
	    if (coups<EAB_START)
	    { 
		jj = FastEndAlphaBeta(play_board, calc_board, player, MAX_COUPS - coups, coups, p_list);
#ifndef SILENT
		if(jj<0)
		    printf("FEAB: i will probably lose by %d\n", -jj);
		else
		    if(jj)
			printf("FEAB: i will probably win by at least %d\n", jj);
		    else 
			printf("FEAB: it can be a draw...\n");
#endif /* SILENT */
	    }
	    else
	    {
		jj = EndAlphaBeta(play_board, calc_board, player, MAX_COUPS - coups, coups, p_list);
#ifndef SILENT
		if(jj<0)
		    printf("i may lose by %d\n", -jj);
		else
		    if(jj)
			printf("i will win by at least %d\n", jj);
		    else 
			printf("you may make a draw...\n");
#endif /* SILENT */
	    }
	    if(player>0)
		PlayWhite(play_board, calc_board, p_list[MAX_COUPS-coups]);
	    else
		PlayBlack(play_board, calc_board, p_list[MAX_COUPS-coups]);
	    ii = p_list[MAX_COUPS-coups];
	    
	}

	ii_last=ii;
	player=-player;
	for(ii=1;ii<=6;ii++)
	    for(jj=1;jj<=6;jj++)
		affichage(play_board[(ii-1)*6+(jj-1)],calc_board[(ii-1)*6+(jj-1)],tabl[ii][jj],( ((ii-1)*6+(jj-1)==ii_last) ? 1 : 0 ));
	Score(play_board, calc_board, &ii, &jj);
	sprintf(buf,"Score -> %d/%d", ii, jj);
	XtSetArg(ar[0],XtNlabel,buf);
	XtSetValues(wscore,ar,1);
	dump=((coups+1)/2)+1;
	sprintf(buf,"Turn %2d",dump);
	XtSetArg(ar[0],XtNlabel,buf);
	XtSetValues(wtour,ar,1);
	if (player==1){
	    XtSetArg(ar[0],XtNlabel,"it's you to play,white...");
	} else{
	    XtSetArg(ar[0],XtNlabel,"it's you to play,black...");
	};
	coups++;
    };
    if (coups>=MAX_COUPS)
    {
	for(ii=1;ii<=6;ii++)
	    for(jj=1;jj<=6;jj++)
		affichage(play_board[(ii-1)*6+(jj-1)],calc_board[(ii-1)*6+(jj-1)],tabl[ii][jj],((ii==ii_last) && (jj==jj_last) ? 1 : 0));
	Score(play_board, calc_board, &ii, &jj);
	sprintf(buf,"Score -> %d/%d", ii, jj);
	XtSetArg(ar[0],XtNlabel,buf);
	XtSetValues(wscore,ar,1);
	dump=((coups+1)/2)+1;
	sprintf(buf,"Turn %2d",dump);
	XtSetArg(ar[0],XtNlabel,buf);
	XtSetValues(wtour,ar,1);
	XtSetArg(ar[0],XtNlabel,"THE END");
	XtSetValues(wtour,ar,1);
	dump = EndScore(play_board, calc_board, 1);
	if (dump)
	{
	    if (dump>0)
	    { 
		XtSetArg(ar[0],XtNlabel,"   WHITE is the WINNER   ");
	    }
	    else
	    { 
		XtSetArg(ar[0],XtNlabel,"   BLACK is the WINNER   ");
	    };
	}
	else { 
	    XtSetArg(ar[0],XtNlabel,"        A DRAW ....      ");
	};
    };
    XtSetValues(wmesg,ar,1);
}

void play(w,client_data,call_data)
    Widget w;
    XtPointer client_data,call_data;
{
    int ii,jj,ii_last,jj_last,dump;

    dump= (int) client_data;
    jj= dump % 10;
    ii= (dump-jj)/10;
    if (IsValidMove(play_board, player, (ii-1)*6+(jj-1)) && coups<MAX_COUPS)
    {
	if(player>0)
	    PlayWhite(play_board, calc_board, (ii-1)*6+(jj-1));
	else
	    PlayBlack(play_board, calc_board, (ii-1)*6+(jj-1));	
	ii_last=ii;
	jj_last=jj;
	player=-player;
	coups++;
	if (is_single)
	{ 
	    compuplay(w,client_data,call_data); 
	}
	else
	{
	    for(ii=1;ii<=6;ii++)
		for(jj=1;jj<=6;jj++)
		    affichage(play_board[(ii-1)*6+(jj-1)],calc_board[(ii-1)*6+(jj-1)],tabl[ii][jj],((ii==ii_last) && (jj==jj_last) ? 1 : 0));
	    Score(play_board, calc_board, &ii, &jj);
	    sprintf(buf,"Score -> %d/%d", ii, jj);
	    XtSetArg(ar[0],XtNlabel,buf);
	    XtSetValues(wscore,ar,1);
	    dump=((coups+1)/2)+1;
	    sprintf(buf,"Turn %2d",dump);
	    XtSetArg(ar[0],XtNlabel,buf);
	    XtSetValues(wtour,ar,1);
	};
    };
    if (coups>=MAX_COUPS)
    {
	XtSetArg(ar[0],XtNlabel,"THE END");
	XtSetValues(wtour,ar,1);
	dump = EndScore(play_board, calc_board, 1);
	if (dump)
	{
	    if (dump>0)
	    { 
		XtSetArg(ar[0],XtNlabel,"   WHITE is the WINNER   ");
	    }
	    else
	    { 
		XtSetArg(ar[0],XtNlabel,"   BLACK is the WINNER   ");
	    };
	}
	else { 
	    XtSetArg(ar[0],XtNlabel,"        A DRAW ....      ");
	};
	XtSetValues(wmesg,ar,1);
    }
    else
    {
	if (player==1) { 
	    XtSetArg(ar[0],XtNlabel,"it's you to play,white...");
	} else { 
	    XtSetArg(ar[0],XtNlabel,"it's you to play,black...");
	};
	XtSetValues(wmesg,ar,1);
    };

}

void reset(w,client_data,call_data)
    Widget w;
    XtPointer client_data,call_data;
{
    int ii,jj;
    coups=0;
    player=1;

    for(i=0;i<36;i++)
    {
	play_board[i]=0;
	calc_board[i]=0;
    }

    for(ii=1;ii<=6;ii++)
	for(jj=1;jj<=6;jj++)
	    affichage(play_board[(ii-1)*6+(jj-1)],calc_board[(ii-1)*6+(jj-1)],tabl[ii][jj], 0);

    XtSetArg(ar[0],XtNlabel,"Score -> 0/0");
    XtSetValues(wscore,ar,1);

    XtSetArg(ar[0],XtNlabel,"it's you to play,white...");
    XtSetValues(wmesg,ar,1);

    XtSetArg(ar[0],XtNlabel,"Turn 1 ");
    XtSetValues(wtour,ar,1);
}

