#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>

#include "types.h"
#include "callback.h"
#include "genbrain.h"

#include "whcas1.bm"	/* BITMAPS */
#include "whcas2.bm"
#include "whcas3.bm"
#include "wwhcas1.bm"
#include "wwhcas2.bm"
#include "wwhcas3.bm"
#include "blcas1.bm"
#include "blcas2.bm"
#include "blcas3.bm"
#include "wblcas1.bm"
#include "wblcas2.bm"
#include "wblcas3.bm"
#include "whitflag.bm"
#include "blacflag.bm"
#include "vide.bm"
#include "whcas1p.bm"
#include "whcas2p.bm"
#include "whcas3p.bm"
#include "wwhcas1p.bm"
#include "blcas1p.bm"
#include "blcas2p.bm"
#include "blcas3p.bm"
#include "wblcas1p.bm"
#include "whitflagp.bm"
#include "blacflagp.bm"
#include "videp.bm"

board		play_board,calc_board;
int 	 	player,is_single,warn_;
XtAppContext    app_context;
Widget          toplevel,wboard,interm,wplay,wreset,wscore,wmesg,wwarn;
Widget	        wquit,wsingle,wtour;
Widget          tabl[8][8];
Pixmap	        pixtab[2][15];
Arg	        args[10];
Arg	        ar[10];
Cardinal        car;
Cardinal        card;
int             i,j,dump,coups;
char            buf[15];
param           brain;

static String fallback_resources[] = { 

	NULL
};



main(argc,argv)
    int    argc;
    char **argv;
{
    car=0;
    XtSetArg(ar[car],XtNwidth,500);car++;
    XtSetArg(ar[car],XtNheight,400);car++;
#ifdef EXP
    XtSetArg(ar[car],XtNtitle,"Xfortress (ver 2.0.1 EXP)");car++;
#else
    XtSetArg(ar[car],XtNtitle,"Xfortress (ver 2.0.1)");car++;
#endif /* EXP */
    toplevel=XtAppInitialize(&app_context,"XFortress",NULL,0,&argc,argv,fallback_resources,NULL,0);
    XtSetValues(toplevel,ar,car);

    interm=XtCreateManagedWidget("Interm",formWidgetClass,toplevel,NULL,0);
    wboard=XtCreateManagedWidget("BOard",formWidgetClass,interm,NULL,0);

    XtSetArg(ar[0],XtNwidth,400);
    XtSetValues(wboard,ar,car);

    XtSetArg(ar[0],XtNfromHoriz,wboard);
    XtSetArg(ar[1],XtNfromVert,NULL);
    wplay=XtCreateManagedWidget(" PLAY ",commandWidgetClass,interm,ar,2);
    XtAddCallback(wplay,XtNcallback,compuplay,0);

    XtSetArg(ar[0],XtNfromHoriz,wboard);
    XtSetArg(ar[1],XtNfromVert,wplay);
    wreset=XtCreateManagedWidget("RESET ",commandWidgetClass,interm,ar,2);
    XtAddCallback(wreset,XtNcallback,reset,0);

    XtSetArg(ar[0],XtNfromHoriz,wboard);
    XtSetArg(ar[1],XtNfromVert,wreset);
    wsingle=XtCreateManagedWidget("SINGLE",commandWidgetClass,interm,ar,2);
    XtAddCallback(wsingle,XtNcallback,single,0);

    XtSetArg(ar[0],XtNfromHoriz,wboard);
    XtSetArg(ar[1],XtNfromVert,wsingle);
    wwarn=XtCreateManagedWidget(" WARN ",commandWidgetClass,interm,ar,2);
    XtAddCallback(wwarn,XtNcallback,setwarn,0);

    XtSetArg(ar[0],XtNfromHoriz,wboard);
    XtSetArg(ar[1],XtNfromVert,wwarn);
    wquit=XtCreateManagedWidget(" QUIT ",commandWidgetClass,interm,ar,2);
    XtAddCallback(wquit,XtNcallback,quit,0);

    XtSetArg(ar[0],XtNfromHoriz,NULL);
    XtSetArg(ar[1],XtNfromVert,wboard);
    wscore=XtCreateManagedWidget("Score -> 0/0",labelWidgetClass,interm,ar,2);

    XtSetArg(ar[0],XtNfromHoriz,wscore);
    XtSetArg(ar[1],XtNfromVert,wboard);
    wtour=XtCreateManagedWidget("Turn 1 ",labelWidgetClass,interm,ar,2);

    XtSetArg(ar[0],XtNfromHoriz,wtour);
    XtSetArg(ar[1],XtNfromVert,wboard);
    wmesg=XtCreateManagedWidget("it's you to play,white...",labelWidgetClass,interm,ar,2);

    for(i=1;i<=6;i++)
	for(j=1;j<=6;j++)
	{
	    sprintf(buf,"case %d,%d",i,j);
	    card=0;
	    XtSetArg(args[card],XtNwidth,50);card++;
	    XtSetArg(args[card],XtNheight,50);card++;
	    if ((i/=1) || (j/=1))
	    {
		XtSetArg(args[card],XtNfromHoriz,tabl[i-1][j]);card++;
		XtSetArg(args[card],XtNfromVert,tabl[i][j-1]);card++;
	    };
	    tabl[i][j]=XtCreateManagedWidget(buf,commandWidgetClass,wboard,args,card);
	    dump=i*10+j;
	    XtAddCallback(tabl[i][j],XtNcallback,play,(XtPointer) dump);
	};
    pixtab[0][0] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),vide_bits    ,vide_width    ,vide_height    );
    pixtab[0][1] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blacflag_bits,blacflag_width,blacflag_height);
    pixtab[0][2] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blcas1_bits  ,blcas1_width  ,blcas1_height  );
    pixtab[0][3] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blcas2_bits  ,blcas2_width  ,blcas2_height  );
    pixtab[0][4] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blcas3_bits  ,blcas3_width  ,blcas3_height  );
    pixtab[0][5] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wblcas1_bits ,wblcas1_width ,wblcas1_height );
    pixtab[0][6] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wblcas2_bits ,wblcas2_width ,wblcas2_height );
    pixtab[0][7] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wblcas3_bits ,wblcas3_width ,wblcas3_height );
    pixtab[0][8] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whitflag_bits,whitflag_width,whitflag_height);
    pixtab[0][9] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whcas1_bits  ,whcas1_width  ,whcas1_height  );
    pixtab[0][10]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whcas2_bits  ,whcas2_width  ,whcas2_height  );
    pixtab[0][11]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whcas3_bits  ,whcas3_width  ,whcas3_height  );
    pixtab[0][12]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wwhcas1_bits ,wwhcas1_width ,wwhcas1_height );
    pixtab[0][13]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wwhcas2_bits ,wwhcas2_width ,wwhcas2_height );
    pixtab[0][14]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wwhcas3_bits ,wwhcas3_width ,wwhcas3_height );

    pixtab[1][0] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),videp_bits    ,videp_width    ,videp_height    ); 
    pixtab[1][1] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blacflagp_bits,blacflagp_width,blacflagp_height);
    pixtab[1][2] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blcas1p_bits  ,blcas1p_width  ,blcas1p_height  ); 
    pixtab[1][3] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blcas2p_bits  ,blcas2p_width  ,blcas2p_height  );
    pixtab[1][4] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),blcas3p_bits  ,blcas3p_width  ,blcas3p_height  ); 
    pixtab[1][5] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wblcas1p_bits ,wblcas1p_width ,wblcas1p_height );
    pixtab[1][6] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wblcas2_bits ,wblcas2_width ,wblcas2_height );
    pixtab[1][7] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wblcas3_bits ,wblcas3_width ,wblcas3_height );
    pixtab[1][8] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whitflagp_bits,whitflagp_width,whitflagp_height);
    pixtab[1][9] =XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whcas1p_bits  ,whcas1p_width  ,whcas1p_height  );
    pixtab[1][10]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whcas2p_bits  ,whcas2p_width  ,whcas2p_height  );
    pixtab[1][11]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),whcas3p_bits  ,whcas3p_width  ,whcas3p_height  );
    pixtab[1][12]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wwhcas1p_bits ,wwhcas1p_width ,wwhcas1p_height );
    pixtab[1][13]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wwhcas2_bits ,wwhcas2_width ,wwhcas2_height );
    pixtab[1][14]=XCreateBitmapFromData(XtDisplay(toplevel),RootWindowOfScreen(XtScreen(toplevel)),wwhcas3_bits ,wwhcas3_width ,wwhcas3_height );

    for(i=1;i<=6;i++)
	for(j=1;j<=6;j++)
	{
	    XtSetArg(args[0],XtNbitmap,pixtab[0][0]);
	    XtSetValues(tabl[i][j],args,1);
	};

    /* initialisation du jeu */

#ifdef EXP
    LoadBrain("brainexp.brn", brain);
#else
    GenBrain(brain);
#endif /* EXP */

    for(i=0;i<36;i++)
    {
	play_board[i]=0;
	calc_board[i]=0;
    }
    coups=0;	
    player=1;
    is_single=1;
    warn_=1;

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}



